package com.nokia.finance.tasks.service;

import com.nokia.finance.tasks.common.R;
import com.nokia.finance.tasks.jobs.car.chengben.CarBaoXianJob;
import com.nokia.finance.tasks.jobs.car.chengben.CarDaWeiXiuJob;
import com.nokia.finance.tasks.jobs.car.chengben.CarLuQiaoJob;
import com.nokia.finance.tasks.jobs.car.chengben.CarNianJianFeiJob;
import com.nokia.finance.tasks.jobs.car.chengben.CarQiTaJob;
import com.nokia.finance.tasks.jobs.car.chengben.CarRanYouJob;
import com.nokia.finance.tasks.jobs.car.chengben.CarWeiXiuJob;
import com.nokia.finance.tasks.jobs.car.ruixing.CarBaoFeiJob;
import com.nokia.finance.tasks.jobs.car.ruixing.CarBaseDataDayJob;
import com.nokia.finance.tasks.jobs.car.ruixing.CarLiChengMonthJob;
import com.nokia.finance.tasks.jobs.car.ruixing.CarWuDanYongCheJob;
import com.nokia.finance.tasks.jobs.car.ruixing.CarYongCheJob;
import com.nokia.finance.tasks.jobs.car.ruixing.CarYueJieJob;
import com.nokia.finance.tasks.jobs.house.chengben.HouseBuildingRepairMonthJob;
import com.nokia.finance.tasks.pojo.RunJobDto;
import org.springframework.stereotype.Service;

@Service
public class JobService {
    private final CarBaseDataDayJob carBaseDataDayJob;
    private final CarYueJieJob carYueJieJob;
    private final CarBaoFeiJob carBaoFeiJob;
    private final CarLiChengMonthJob carLiChengMonthJob;
    private final CarWuDanYongCheJob carWuDanYongCheJob;
    private final CarYongCheJob carYongCheJob;
    private final CarRanYouJob carRanYouJob;
    private final CarDaWeiXiuJob carDaWeiXiuJob;
    private final CarWeiXiuJob carWeiXiuJob;
    private final CarLuQiaoJob carLuQiaoJob;
    private final CarBaoXianJob carBaoXianJob;
    private final CarNianJianFeiJob carNianJianFeiJob;
    private final CarQiTaJob carQiTaJob;
    private final HouseBuildingRepairMonthJob houseBuildingRepairMonthJob;

    public JobService(CarBaseDataDayJob carBaseDataDayJob, CarYueJieJob carYueJieJob, CarBaoFeiJob carBaoFeiJob,
                      CarLiChengMonthJob carLiChengMonthJob, CarWuDanYongCheJob carWuDanYongCheJob,
                      CarYongCheJob carYongCheJob,
                      CarRanYouJob carRanYouJob, CarDaWeiXiuJob carDaWeiXiuJob, CarWeiXiuJob carWeiXiuJob,
                      CarLuQiaoJob carLuQiaoJob, CarBaoXianJob carBaoXianJob, CarNianJianFeiJob carNianJianFeiJob,
                      CarQiTaJob carQiTaJob, HouseBuildingRepairMonthJob houseBuildingRepairMonthJob) {
        this.carBaseDataDayJob = carBaseDataDayJob;
        this.carYueJieJob = carYueJieJob;
        this.carBaoFeiJob = carBaoFeiJob;
        this.carLiChengMonthJob = carLiChengMonthJob;
        this.carWuDanYongCheJob = carWuDanYongCheJob;
        this.carYongCheJob = carYongCheJob;
        this.carRanYouJob = carRanYouJob;
        this.carDaWeiXiuJob = carDaWeiXiuJob;
        this.carWeiXiuJob = carWeiXiuJob;
        this.carLuQiaoJob = carLuQiaoJob;
        this.carBaoXianJob = carBaoXianJob;
        this.carNianJianFeiJob = carNianJianFeiJob;
        this.carQiTaJob = carQiTaJob;
        this.houseBuildingRepairMonthJob = houseBuildingRepairMonthJob;
    }

    public R<Object> runJob(RunJobDto dto) {
        switch (dto.getJobName()) {
            case CAR_BASE_DATA_DAY_JOB:
                carBaseDataDayJob.runJob();
                break;
            case CAR_YUE_JIE_JOB:
                carYueJieJob.runJob();
                break;
            case CAR_BAO_FEI_JOB:
                carBaoFeiJob.runJob();
                break;
            case CAR_LI_CHENG_MONTH_JOB:
                carLiChengMonthJob.runJob();
                break;
            case CAR_WU_DAN_YONG_CHE_JOB:
                carWuDanYongCheJob.runJob();
                break;
            case CAR_YONG_CHE_JOB:
                carYongCheJob.runJob();
                break;
            case CAR_RAN_YOU_JOB:
                carRanYouJob.runJob();
                break;
            case CAR_DA_WEI_XIU_JOB:
                carDaWeiXiuJob.runJob();
                break;
            case CAR_WEI_XIU_JOB:
                carWeiXiuJob.runJob();
                break;
            case CAR_LU_QIAO_JOB:
                carLuQiaoJob.runJob();
                break;
            case CAR_BAO_XIAN_JOB:
                carBaoXianJob.runJob();
                break;
            case CAR_NIAN_JIAN_FEI_JOB:
                carNianJianFeiJob.runJob();
                break;
            case CAR_QI_TA_JOB:
                carQiTaJob.runJob();
                break;
            case HOUSE_BUILDING_REPAIR_MONTH_JOB:
                houseBuildingRepairMonthJob.runJob();
                break;
            default:
                break;
        }
        return R.ok();
    }
}
